/* ANDROS : derived from , and the 'real' krb5_gss_glue.c
* routines to map from mechglue gss_mechanism prototypes to krb5_gss_XXX 
* routines. 
* NOTE: GSS_WRAP is not included in mechglue/mglueP.h
*/

#include "gssapiP_krb5.h"

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_accept_sec_context(context,
           minor_status, context_handle, verifier_cred_handle,
		       input_token, input_chan_bindings, src_name, mech_type, 
		       output_token, ret_flags, time_rec, delegated_cred_handle)
     void  *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t FAR *context_handle;
     gss_cred_id_t verifier_cred_handle;
     gss_buffer_t input_token;
     gss_channel_bindings_t input_chan_bindings;
     gss_name_t FAR *src_name;
     gss_OID FAR *mech_type;
     gss_buffer_t output_token;
     OM_uint32 FAR *ret_flags;
     OM_uint32 FAR *time_rec;
     gss_cred_id_t FAR *delegated_cred_handle;
{
   return(krb5_gss_accept_sec_context(minor_status,
				      context_handle,
				      verifier_cred_handle,
				      input_token,
				      input_chan_bindings,
				      src_name,
				      mech_type,
				      output_token,
				      ret_flags,
				      time_rec,
				      delegated_cred_handle));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_acquire_cred(context,
	        minor_status, desired_name, time_req, desired_mechs, cred_usage, 
					output_cred_handle, actual_mechs, time_rec)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_name_t desired_name;
     OM_uint32 time_req;
     gss_OID_set desired_mechs;
     gss_cred_usage_t cred_usage;
     gss_cred_id_t FAR *output_cred_handle;
     gss_OID_set FAR *actual_mechs;
     OM_uint32 FAR *time_rec;
{
   return(krb5_gss_acquire_cred(minor_status,
				desired_name,
				time_req,
				desired_mechs,
				cred_usage,
				output_cred_handle,
				actual_mechs,
				time_rec));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_add_cred(context,
	     minor_status, input_cred_handle, desired_name, desired_mech,
	     cred_usage, initiator_time_req, acceptor_time_req,
	     output_cred_handle, actual_mechs, initiator_time_rec,
	     acceptor_time_rec)
    void *context;
    OM_uint32		FAR *minor_status;
    gss_cred_id_t	input_cred_handle;
    gss_name_t		desired_name;
    gss_OID		desired_mech;
    gss_cred_usage_t	cred_usage;
    OM_uint32		initiator_time_req;
    OM_uint32		acceptor_time_req;
    gss_cred_id_t	FAR *output_cred_handle;
    gss_OID_set		FAR *actual_mechs;
    OM_uint32		FAR *initiator_time_rec;
    OM_uint32		FAR *acceptor_time_rec;
{
    return(krb5_gss_add_cred(minor_status, input_cred_handle, desired_name,
			     desired_mech, cred_usage, initiator_time_req,
			     acceptor_time_req, output_cred_handle,
			     actual_mechs, initiator_time_rec,
			     acceptor_time_rec));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_compare_name(context,minor_status, name1, name2, name_equal)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_name_t name1;
     gss_name_t name2;
     int FAR *name_equal;
{
   return(krb5_gss_compare_name(minor_status, name1,
				name2, name_equal));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_context_time(context,minor_status, context_handle, time_rec)
     void *context; 
     OM_uint32 FAR *minor_status; 
     gss_ctx_id_t context_handle;
     OM_uint32 FAR *time_rec;
{
   return(krb5_gss_context_time(minor_status, context_handle,
				time_rec));
}


GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_delete_sec_context(context,
	        minor_status, context_handle, output_token)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t FAR *context_handle;
     gss_buffer_t output_token;
{
   return(krb5_gss_delete_sec_context(minor_status,
				      context_handle, output_token));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_display_name(context,
	        minor_status, input_name, output_name_buffer, output_name_type)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_name_t input_name;
     gss_buffer_t output_name_buffer;
     gss_OID FAR *output_name_type;
{
   return(krb5_gss_display_name(minor_status, input_name,
				output_name_buffer, output_name_type));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_display_status(context,minor_status, status_value, status_type,
		   mech_type, message_context, status_string)
     void *context;
     OM_uint32 FAR *minor_status;
     OM_uint32 status_value;
     int status_type;
     gss_OID mech_type;
     OM_uint32 FAR *message_context;
     gss_buffer_t status_string;
{
   return(krb5_gss_display_status(minor_status, status_value,
				  status_type, mech_type, message_context,
				  status_string));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_export_sec_context(context,
	      minor_status, context_handle, interprocess_token)
     void *context;
     OM_uint32		FAR *minor_status;
     gss_ctx_id_t	FAR *context_handle;
     gss_buffer_t	interprocess_token;
{
   return(krb5_gss_export_sec_context(minor_status,
				      context_handle,
				      interprocess_token));
}


GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_import_name(context,
	        minor_status, input_name_buffer, input_name_type, output_name)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_buffer_t input_name_buffer;
     gss_OID input_name_type;
     gss_name_t FAR *output_name;
{
   return(krb5_gss_import_name(minor_status, input_name_buffer,
			       input_name_type, output_name));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_import_sec_context(context,
	      minor_status, interprocess_token, context_handle)
     void *context;
     OM_uint32		FAR *minor_status;
     gss_buffer_t	interprocess_token;
     gss_ctx_id_t	FAR *context_handle;
{
   return(krb5_gss_import_sec_context(minor_status,
				      interprocess_token,
				      context_handle));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_indicate_mechs(context,minor_status, mech_set)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_OID_set FAR *mech_set;
{
   return(krb5_gss_indicate_mechs(minor_status, mech_set));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_init_sec_context(context,
				 minor_status, claimant_cred_handle, context_handle,
		     target_name, mech_type, req_flags, time_req,
		     input_chan_bindings, input_token, actual_mech_type,
		     output_token, ret_flags, time_rec)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_cred_id_t claimant_cred_handle;
     gss_ctx_id_t FAR *context_handle;
     gss_name_t target_name;
     gss_OID mech_type;
     OM_uint32 req_flags;
     OM_uint32 time_req;
     gss_channel_bindings_t input_chan_bindings;
     gss_buffer_t input_token;
     gss_OID FAR *actual_mech_type;
     gss_buffer_t output_token;
     OM_uint32 FAR *ret_flags;
     OM_uint32 FAR *time_rec;
{
   return(krb5_gss_init_sec_context(minor_status,
				    claimant_cred_handle, context_handle,
				    target_name, mech_type, req_flags,
				    time_req, input_chan_bindings, input_token,
				    actual_mech_type, output_token, ret_flags,
				    time_rec));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_inquire_context(context,
	      minor_status, context_handle, initiator_name, acceptor_name,
		    lifetime_rec, mech_type, ret_flags,
		    locally_initiated, open)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t context_handle;
     gss_name_t FAR *initiator_name;
     gss_name_t FAR *acceptor_name;
     OM_uint32 FAR *lifetime_rec;
     gss_OID FAR *mech_type;
     OM_uint32 FAR *ret_flags;
     int FAR *locally_initiated;
     int FAR *open;
{
   return(krb5_gss_inquire_context(minor_status, context_handle,
				   initiator_name, acceptor_name, lifetime_rec,
				   mech_type, ret_flags, locally_initiated,
				   open));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_inquire_cred(context,
	      minor_status, cred_handle, name, lifetime_ret,
		    cred_usage, mechanisms)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_cred_id_t cred_handle;
     gss_name_t FAR *name;
     OM_uint32 FAR *lifetime_ret;
     gss_cred_usage_t FAR *cred_usage;
     gss_OID_set FAR *mechanisms;
{
   return(krb5_gss_inquire_cred(minor_status, cred_handle,
				name, lifetime_ret, cred_usage, mechanisms));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_inquire_cred_by_mech(context,
	      minor_status, cred_handle, mech_type, name,
			  initiator_lifetime, acceptor_lifetime, cred_usage)
     void *context;
     OM_uint32		FAR *minor_status;
     gss_cred_id_t	cred_handle;
     gss_OID		mech_type;
     gss_name_t		FAR *name;
     OM_uint32		FAR *initiator_lifetime;
     OM_uint32		FAR *acceptor_lifetime;
     gss_cred_usage_t	FAR *cred_usage;
{
   return(krb5_gss_inquire_cred_by_mech(minor_status, cred_handle,
					mech_type, name, initiator_lifetime,
					acceptor_lifetime, cred_usage));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_inquire_names_for_mech(context,minor_status, mechanism, name_types)
    void *context;
    OM_uint32	FAR *minor_status;
    gss_OID	mechanism;
    gss_OID_set	FAR *name_types;
{
    return(krb5_gss_inquire_names_for_mech(minor_status,
					   mechanism,
					   name_types));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_oid_to_str(minor_status, oid, oid_str)
    OM_uint32		FAR *minor_status;
    gss_OID		oid;
    gss_buffer_t	oid_str;
{
    return(generic_gss_oid_to_str(minor_status, oid, oid_str));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_process_context_token(context,
	        minor_status, context_handle, token_buffer)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t context_handle;
     gss_buffer_t token_buffer;
{
   return(krb5_gss_process_context_token(minor_status,
					 context_handle, token_buffer));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_release_cred(context,minor_status, cred_handle)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_cred_id_t FAR *cred_handle;
{
   return(krb5_gss_release_cred(minor_status, cred_handle));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_release_name(context,minor_status, input_name)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_name_t FAR *input_name;
{
   return(krb5_gss_release_name(minor_status, input_name));
}


/* ANDROS added this function */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_internal_release_oid(context,minor_status, oid)
     void *context;
     OM_uint32	FAR *minor_status;
     gss_OID	FAR *oid;
{
    return(krb5_gss_release_oid(minor_status, oid));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_release_oid(context,minor_status, oid)
     void *context;
     OM_uint32	FAR *minor_status;
     gss_OID	FAR *oid;
{
    return(krb5_gss_release_oid(minor_status, oid));
}

/* V1 only */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_seal(context,minor_status, context_handle, conf_req_flag, qop_req,
	 input_message_buffer, conf_state, output_message_buffer)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t context_handle;
     int conf_req_flag;
     int qop_req;
     gss_buffer_t input_message_buffer;
     int FAR *conf_state;
     gss_buffer_t output_message_buffer;
{
   return(krb5_gss_seal(minor_status, context_handle,
			conf_req_flag, qop_req, input_message_buffer,
			conf_state, output_message_buffer));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_sign(context,minor_status, context_handle,
	      qop_req, message_buffer, 
	      message_token)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t context_handle;
     int qop_req;
     gss_buffer_t message_buffer;
     gss_buffer_t message_token;
{
   return(krb5_gss_sign(minor_status, context_handle,
			qop_req, message_buffer, message_token));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_verify_mic(context,minor_status, context_handle,
	       message_buffer, token_buffer, qop_state)
     void *context;
     OM_uint32		FAR *minor_status;
     gss_ctx_id_t	context_handle;
     gss_buffer_t	message_buffer;
     gss_buffer_t	token_buffer;
     gss_qop_t		FAR *qop_state;
{
    return(krb5_gss_verify_mic(minor_status, context_handle,
			       message_buffer, token_buffer, qop_state));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_wrap(context,
	      minor_status, context_handle, conf_req_flag, qop_req,
	      input_message_buffer, conf_state, output_message_buffer)
    void *context;
    OM_uint32		FAR *minor_status;
    gss_ctx_id_t	context_handle;
    int			conf_req_flag;
    gss_qop_t		qop_req;
    gss_buffer_t	input_message_buffer;
    int			FAR *conf_state;
    gss_buffer_t	output_message_buffer;
{
    return(krb5_gss_wrap(minor_status, context_handle, conf_req_flag, qop_req,
			 input_message_buffer, conf_state,
			 output_message_buffer));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_str_to_oid(minor_status, oid_str, oid)
    OM_uint32		FAR *minor_status;
    gss_buffer_t	oid_str;
    gss_OID		FAR *oid;
{
    return(generic_gss_str_to_oid(minor_status, oid_str, oid));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_test_oid_set_member(minor_status, member, set, present)
    OM_uint32	FAR *minor_status;
    gss_OID	member;
    gss_OID_set	set;
    int		FAR *present;
{
    return(generic_gss_test_oid_set_member(minor_status, member, set,
					   present));
}

/* V1 only */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_unseal(context,minor_status, context_handle, input_message_buffer,
	   output_message_buffer, conf_state, qop_state)
     void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t context_handle;
     gss_buffer_t input_message_buffer;
     gss_buffer_t output_message_buffer;
     int FAR *conf_state;
     int FAR *qop_state;
{
   return(krb5_gss_unseal(minor_status, context_handle,
			  input_message_buffer, output_message_buffer,
			  conf_state, qop_state));
}

/* V2 */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_unwrap(context,minor_status, context_handle, 
	   input_message_buffer, output_message_buffer, conf_state, qop_state)
    void *context;
    OM_uint32		FAR *minor_status;
    gss_ctx_id_t	context_handle;
    gss_buffer_t	input_message_buffer;
    gss_buffer_t	output_message_buffer;
    int			FAR *conf_state;
    gss_qop_t		FAR *qop_state;
{
    return(krb5_gss_unwrap(minor_status, context_handle, input_message_buffer,
			   output_message_buffer, conf_state, qop_state));
}

/* V1 only */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_verify(context,minor_status, context_handle, message_buffer,
	   token_buffer, qop_state)
	   void *context;
     OM_uint32 FAR *minor_status;
     gss_ctx_id_t context_handle;
     gss_buffer_t message_buffer;
     gss_buffer_t token_buffer;
     int FAR *qop_state;
{
   return(krb5_gss_verify(minor_status,
			  context_handle,
			  message_buffer,
			  token_buffer,
			  qop_state));
}

/* V2 interface */
GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_wrap_size_limit(context,
	      minor_status, context_handle, conf_req_flag,
		    qop_req, req_output_size, max_input_size)
    void *context;
    OM_uint32		FAR *minor_status;
    gss_ctx_id_t	context_handle;
    int			conf_req_flag;
    gss_qop_t		qop_req;
    OM_uint32		req_output_size;
    OM_uint32		FAR *max_input_size;
{
   return(krb5_gss_wrap_size_limit(minor_status, context_handle,
				   conf_req_flag, qop_req,
				   req_output_size, max_input_size));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_pname_to_uid(context,pname,name_oid,mech_oid,uid)
      void * context;           /* context */
      char *pname;   /* principal name */ 
      gss_OID name_oid;    /* name_type */
      gss_OID mech_oid;    /* mech_type */
      uid_t *uid;  /* uid (OUT) */
{
   return(krb5_pname_to_uid(context, pname, name_oid, mech_oid, uid));
}

GSS_DLLIMP OM_uint32 KRB5_CALLCONV
krb5_mech_gss_duplicate_name(context,minor_status, input_name, dest_name)
  void * context;           /* context */
  OM_uint32  *minor_status;
  const gss_name_t input_name;
  gss_name_t *dest_name;
{
  return krb5_gss_duplicate_name(minor_status, input_name, dest_name);
}

