#include "../mechglue/mglueP.h"
#include "gssapiP_krb5.h"
#include "krb5mech.h"

/*
 * This is the declaration of the mechs_array table for Kerberos V5.
 * If the gss_mechanism structure changes, so should this array!  I
 * told you it was a private interface!
 * NOTE: this was the origional mechanism -
 *	{{5,"\053\005\001\005\002"},
 */

static struct gss_config krb5_mech_mechanism =
	{{9, "\052\206\110\206\367\022\001\002\002"},
	0,				/* context, to be filled */
	krb5_mech_gss_acquire_cred,
	krb5_mech_gss_release_cred,
	krb5_mech_gss_init_sec_context,
	krb5_mech_gss_accept_sec_context,
	krb5_mech_gss_process_context_token,
	krb5_mech_gss_delete_sec_context,
	krb5_mech_gss_context_time,
	krb5_mech_gss_sign,
	krb5_mech_gss_verify,
	krb5_mech_gss_seal,
	krb5_mech_gss_unseal,
	krb5_mech_gss_display_status,
	krb5_mech_gss_indicate_mechs,
	krb5_mech_gss_compare_name,
	krb5_mech_gss_display_name,
	krb5_mech_gss_import_name,
	krb5_mech_gss_release_name,
	krb5_mech_gss_inquire_cred,
	krb5_mech_gss_add_cred,
	krb5_mech_gss_export_sec_context,
	krb5_mech_gss_import_sec_context,
	krb5_mech_gss_inquire_cred_by_mech,
	krb5_mech_gss_inquire_names_for_mech,
	krb5_mech_gss_inquire_context,
	krb5_mech_gss_internal_release_oid,
	krb5_mech_gss_wrap_size_limit,     
	krb5_mech_pname_to_uid,
	krb5_mech_gss_duplicate_name,
};


#if 0
OM_uint32
krb5_mech_gss_get_context(void **	context)
{
    if (context == NULL)
	return GSS_S_FAILURE;
    if (kg_context) {
	*context = kg_context;
	return (GSS_S_COMPLETE);
    }
    if (krb5_mech_init_context(&kg_context))
	return GSS_S_FAILURE;
    if (krb5_mech_ser_context_init(kg_context) ||
	krb5_mech_ser_auth_context_init(kg_context) ||
	krb5_mech_ser_ccache_init(kg_context) ||
	krb5_mech_ser_rcache_init(kg_context) ||
	krb5_mech_ser_keytab_init(kg_context) ||
	kg_ser_context_init(kg_context)) {
	krb5_mech_free_context(kg_context);
	kg_context = 0;
	return (GSS_S_FAILURE);
    }
    *context = kg_context;
    return GSS_S_COMPLETE;
}

gss_mechanism
krb5_mech_gss_initialize()
{

    kg_get_context(&(krb5_mech_mechanism.context));
    return (&krb5_mech_mechanism);
}
#endif /*0*/
/* krb5 code doesn't use the gss_mechanism context */
gss_mechanism
krb5_gss_initialize()
{
    return (&krb5_mech_mechanism);
}
