/*
 *  spkm3/d2i_dh_pu.c
 * 
 *  Derived from SSLeay-0.9.0b/crypto/asn1/d2i_r_pu.c
 *
 *  Copyright (c) 2001 The Regents of the University of Michigan.
 *  All rights reserved.
 *
 *  Andy Adamson <andros@umich.edu>
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the University nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 *  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *  DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 *  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include <cryptlib.h>
#include <bn.h>
#include <rsa.h>
#include <objects.h>
#include <asn1_mac.h>

DH *d2i_DHPublicKey(a,pp,length)
DH **a;
unsigned char **pp;
long length;
{

  int i=ASN1_R_PARSING;
  ASN1_INTEGER *bs=NULL;
  M_ASN1_D2I_vars(a,DH *,DH_new);

  M_ASN1_D2I_Init();
  M_ASN1_D2I_start_sequence();
  M_ASN1_D2I_get(bs,d2i_ASN1_INTEGER);
  if ((ret->pub_key=BN_bin2bn(bs->data,bs->length,ret->pub_key)) == NULL) goto err_bn;

  ASN1_INTEGER_free(bs);
  bs=NULL;

  M_ASN1_D2I_Finish_2(a);

err_bn:
  i=ERR_R_BN_LIB;
err:
/*
  ASN1err(ASN1_F_D2I_DHPUBLICKEY,i);
*/
  if ((ret != NULL) && ((a == NULL) || (*a != ret))) DH_free(ret);
  if (bs != NULL) ASN1_INTEGER_free(bs);
  return(NULL);
}
