/*
 * Copyright (C) 1998-1999 ValiCert, Inc.
 * All rights reserved.
 *
 * ValiCert ASN.1 Parser Package
 *
 *
 * This package is ValiCert ASN.1 Parser used to generate code compatible
 * with the SSLeay distribution written by Eric Young (eay@mincom.oz.au).
 * The implementation was written so as to conform with SSLeay 0.6.6.
 *
 * ValiCert ASN.1 Parser developed by Jack Kabat (jackk@valicert.com)
 * with special thanks to Gordon Chaffee (chaffee@cs.berkeley.edu) who had
 * started the development of this parser as well to  Ambarish Malpani
 * (ambarish@valicert.com) and Krishna Vedati (krishnav@valicert.com) for
 * their assistance and contributions.
 * 
 * This library is free for commercial and non-commercial use as long as
 * the following conditions are adhered to.  The following conditions
 * apply to all code found in this distribution.
 * 
 * Copyright remains ValiCert, Inc. and as such any Copyright notices in
 * the code are not to be removed.
 * If this package is used in a product, Jack Kabat should be given
 * attribution as the author of the ASN.1 parser and ValiCert, Inc.
 * as having its copyright.
 * This can be in the form of a textual message at program startup or
 * in documentation (online or textual) provided with the package.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *    "This product includes ValiCert ASN.1 Parser or code generated by
 *     ValiCert ASN.1 Parser copyright ValiCert, Inc. and written by
 *     Jack Kabat (jackk@valicert.com)".
 *
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR, ValiCert, Inc. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * The license and distribution terms for any publicly available version or
 * derivative of this code cannot be changed.  i.e. this code cannot simply be
 * copied and put under another distribution license.
 *
 */

/*
 * The following macros need to be added to the crypto/asn1/asn1_mac.h
 * SSLeay distribution file. The MACROS are used when processing
 * ASN.1 definitions containing the CHOICE construct.
 */

#define M_ASN1_D2I_start_choice() \
	c.eos = 0; c.slen=length

#define M_ASN1_I2D_choice_total() \
	if (pp == NULL) return(ret); \
		p= *pp;

#define M_ASN1_D2I_FinishChoice(a,func,e) \
	M_ASN1_D2I_FinishChoice_2(a); \
	err:\
		ASN1err((e),c.error); \
		if ((ret != NULL) && ((a == NULL) || (*a != ret))) func(ret); \
			return(NULL)

#define M_ASN1_D2I_FinishChoice_2(a) \
	*pp=c.p; \
	if (a != NULL) (*a)=ret; \
		return(ret);

